package model;

public class Board {
	private Piece[] pieces;

	public Board() {
		pieces = new Piece[64];

		// initialisation of the board
		for(int i = 0 ; i < 64 ; i++) {
			pieces[i] = null;
		}

		int ligne = 0;
		for(int color = Piece.WHITE ; color == Piece.WHITE || color == Piece.BLACK ; color++) {

			// placement of pawns
			if(color == Piece.WHITE) { ligne = 2; }
			else { ligne = 7; }
			for(int i = Position.a ; i <= Position.h ; i++) {
				this.set(new Pawn(new Position(i, ligne), color));
			}

			// placement of rook, knight, bishop, queen, king
			if(color == Piece.WHITE) { ligne = 1; }
			else { ligne = 8; }
			/*this.set(new Rook(new Position(Position.a, ligne), color);
			this.set(new Knight(new Position(Position.b, ligne), color);
			this.set(new Bishop(new Position(Position.c, ligne), color);
			this.set(new Queen(new Position(Position.d, ligne), color);
			this.set(new King(new Position(Position.e, ligne), color);
			this.set(new Bishop(new Position(Position.f, ligne), color);
			this.set(new Knight(new Position(Position.g, ligne), color);
			this.set(new Rook(new Position(Position.h, ligne), color);*/
		}
		//this.set(new Rook(new Position(Position.a, 1), Piece.WHITE);
		// to finish...

	}

	public void set(Piece piece) {
		pieces[piece.getPosition().getID()] = piece;
	}

	public boolean isFree(Position p) {
		return (pieces[p.getID()] == null);
	}
	public boolean isBlack(Position p) {
		return (pieces[p.getID()].getColor() == Piece.BLACK);
	}

	public boolean isWhite(Position p) {
		return (pieces[p.getID()].getColor() == Piece.WHITE);
	}
	public boolean isKing(Position p) {
		return (pieces[p.getID()].getClass() == Pawn.class); // to change to king later
	}
}
